"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _core = require("@emotion/core");

var _reactSyntaxHighlighter = require("react-syntax-highlighter");

var _supportedLanguages = require("../supportedLanguages");

var _themeBuilder = require("../themes/themeBuilder");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var LANGUAGE_FALLBACK = 'text';
var DEFAULT_LINE_EL_ATTR_OBJ = {
  'data-ds--code--row': ''
};

var getLineStyleObject = function getLineStyleObject(lineNumber, testId) {
  return testId ? _objectSpread({
    'data-testid': "".concat(testId, "-line-").concat(lineNumber)
  }, DEFAULT_LINE_EL_ATTR_OBJ) : DEFAULT_LINE_EL_ATTR_OBJ;
};

var CodeBlock = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2.default)(CodeBlock, _PureComponent);

  var _super = _createSuper(CodeBlock);

  function CodeBlock() {
    var _this;

    (0, _classCallCheck2.default)(this, CodeBlock);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "getHighlightStyles", function (lineNumber, highlightedLines) {
      if (!_this.props.highlight || highlightedLines.length === 0) {
        return getLineStyleObject(lineNumber, _this.props.testId);
      }

      if (highlightedLines.includes(lineNumber)) {
        var highlightedDataAttrObj = {
          'data-ds--code--row--highlight': ''
        };
        return _objectSpread(_objectSpread({}, highlightedDataAttrObj), getLineStyleObject(lineNumber, _this.props.testId));
      }

      return getLineStyleObject(lineNumber, _this.props.testId);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleCopy", function (event) {
      /**
       * We don't want to copy the markup after highlighting, but rather the preformatted text in the selection
       */
      var data = event.nativeEvent.clipboardData;

      if (data) {
        event.preventDefault();
        var selection = window.getSelection();

        if (selection === null) {
          return;
        }

        var selectedText = selection.toString();
        var document = "<!doctype html><html><head></head><body><pre>".concat(selectedText, "</pre></body></html>");
        data.clearData();
        data.setData('text/html', document);
        data.setData('text/plain', selectedText);
      }
    });
    return _this;
  }

  (0, _createClass2.default)(CodeBlock, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      // TODO look at memoising this
      var numLines = (this.props.text || '').split('\n').length;

      var _applyTheme = (0, _themeBuilder.applyTheme)(_objectSpread(_objectSpread({}, this.props.theme), this.props.themeOverride), numLines),
          lineNumberStyle = _applyTheme.lineNumberStyle,
          codeBlockStyle = _applyTheme.codeBlockStyle,
          codeContainerStyle = _applyTheme.codeContainerStyle,
          codeLayoutContainer = _applyTheme.codeLayoutContainer;

      var props = {
        language: (0, _supportedLanguages.normalizeLanguage)(this.props.language || LANGUAGE_FALLBACK),
        PreTag: 'span',
        style: codeBlockStyle,
        lineNumberStyle: lineNumberStyle,
        showLineNumbers: this.props.showLineNumbers,
        codeTagProps: {
          style: codeContainerStyle(this.props.showLineNumbers)
        }
      };
      var _this$props = this.props,
          _this$props$highlight = _this$props.highlightedStartText,
          highlightedStartText = _this$props$highlight === void 0 ? '' : _this$props$highlight,
          _this$props$highlight2 = _this$props.highlightedEndText,
          highlightedEndText = _this$props$highlight2 === void 0 ? '' : _this$props$highlight2;
      var highlightedLines = this.props.highlight.split(',').map(function (num) {
        if (num.indexOf('-') > 0) {
          // We found a line group, e.g. 1-3
          var _num$split$map$sort = num.split('-').map(Number) // Sort by lowest value first, highest value last.
          .sort(function (a, b) {
            return a - b;
          }),
              _num$split$map$sort2 = (0, _slicedToArray2.default)(_num$split$map$sort, 2),
              from = _num$split$map$sort2[0],
              to = _num$split$map$sort2[1];

          return Array(to + 1).fill(undefined).map(function (_, index) {
            return index;
          }).slice(from, to + 1);
        }

        return Number(num);
      }).reduce(function (acc, val) {
        return acc.concat(val);
      }, []) || [];
      return (0, _core.jsx)("div", {
        "data-testid": this.props.testId,
        "data-code-block": "",
        css: codeLayoutContainer(highlightedStartText, highlightedEndText, this.props.showLineNumbers)
      }, (0, _core.jsx)(_reactSyntaxHighlighter.PrismAsync, (0, _extends2.default)({
        "data-code-lang": this.props.language // Wrap lines is needed to set styles on the line.
        // We use this to set opacity if highlight specific lines.
        ,
        wrapLines: this.props.highlight.length > 0 || this.props.testId,
        lineProps: function lineProps(line) {
          return _this2.getHighlightStyles(line, highlightedLines);
        }
      }, props), this.props.text));
    }
  }]);
  return CodeBlock;
}(_react.PureComponent);

exports.default = CodeBlock;
(0, _defineProperty2.default)(CodeBlock, "displayName", 'CodeBlock');
(0, _defineProperty2.default)(CodeBlock, "defaultProps", {
  showLineNumbers: true,
  language: LANGUAGE_FALLBACK,
  theme: {},
  themeOverride: {},
  highlight: '',
  highlightedStartText: 'Highlight start',
  highlightedEndText: 'Highlight end'
});