import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React, { PureComponent } from 'react';
import { PrismAsyncLight as SyntaxHighlighter } from 'react-syntax-highlighter';
import { normalizeLanguage } from '../supportedLanguages';
import { applyTheme } from '../themes/themeBuilder';
export default class Code extends PureComponent {
  render() {
    const {
      inlineCodeStyle
    } = applyTheme(this.props.theme);
    const language = normalizeLanguage(this.props.language);
    const props = {
      language,
      PreTag: this.props.preTag,
      style: this.props.codeStyle || inlineCodeStyle,
      codeTagProps: this.props.codeTagProps
    };
    return /*#__PURE__*/React.createElement(SyntaxHighlighter, _extends({
      "data-code-lang": this.props.language,
      "data-testid": this.props.testId
    }, props), this.props.text);
  }

}

_defineProperty(Code, "defaultProps", {
  theme: {},
  codeTagProps: {},
  preTag: 'span'
});