import _extends from "@babel/runtime/helpers/extends";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

/** @jsx jsx */
import React, { PureComponent } from 'react';
import { jsx } from '@emotion/core';
import { PrismAsync as SyntaxHighlighter } from 'react-syntax-highlighter';
import { normalizeLanguage } from '../supportedLanguages';
import { applyTheme } from '../themes/themeBuilder';
var LANGUAGE_FALLBACK = 'text';
var DEFAULT_LINE_EL_ATTR_OBJ = {
  'data-ds--code--row': ''
};

var getLineStyleObject = function getLineStyleObject(lineNumber, testId) {
  return testId ? _objectSpread({
    'data-testid': "".concat(testId, "-line-").concat(lineNumber)
  }, DEFAULT_LINE_EL_ATTR_OBJ) : DEFAULT_LINE_EL_ATTR_OBJ;
};

var CodeBlock = /*#__PURE__*/function (_PureComponent) {
  _inherits(CodeBlock, _PureComponent);

  var _super = _createSuper(CodeBlock);

  function CodeBlock() {
    var _this;

    _classCallCheck(this, CodeBlock);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "getHighlightStyles", function (lineNumber, highlightedLines) {
      if (!_this.props.highlight || highlightedLines.length === 0) {
        return getLineStyleObject(lineNumber, _this.props.testId);
      }

      if (highlightedLines.includes(lineNumber)) {
        var highlightedDataAttrObj = {
          'data-ds--code--row--highlight': ''
        };
        return _objectSpread(_objectSpread({}, highlightedDataAttrObj), getLineStyleObject(lineNumber, _this.props.testId));
      }

      return getLineStyleObject(lineNumber, _this.props.testId);
    });

    _defineProperty(_assertThisInitialized(_this), "handleCopy", function (event) {
      /**
       * We don't want to copy the markup after highlighting, but rather the preformatted text in the selection
       */
      var data = event.nativeEvent.clipboardData;

      if (data) {
        event.preventDefault();
        var selection = window.getSelection();

        if (selection === null) {
          return;
        }

        var selectedText = selection.toString();
        var document = "<!doctype html><html><head></head><body><pre>".concat(selectedText, "</pre></body></html>");
        data.clearData();
        data.setData('text/html', document);
        data.setData('text/plain', selectedText);
      }
    });

    return _this;
  }

  _createClass(CodeBlock, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      // TODO look at memoising this
      var numLines = (this.props.text || '').split('\n').length;

      var _applyTheme = applyTheme(_objectSpread(_objectSpread({}, this.props.theme), this.props.themeOverride), numLines),
          lineNumberStyle = _applyTheme.lineNumberStyle,
          codeBlockStyle = _applyTheme.codeBlockStyle,
          codeContainerStyle = _applyTheme.codeContainerStyle,
          codeLayoutContainer = _applyTheme.codeLayoutContainer;

      var props = {
        language: normalizeLanguage(this.props.language || LANGUAGE_FALLBACK),
        PreTag: 'span',
        style: codeBlockStyle,
        lineNumberStyle: lineNumberStyle,
        showLineNumbers: this.props.showLineNumbers,
        codeTagProps: {
          style: codeContainerStyle(this.props.showLineNumbers)
        }
      };
      var _this$props = this.props,
          _this$props$highlight = _this$props.highlightedStartText,
          highlightedStartText = _this$props$highlight === void 0 ? '' : _this$props$highlight,
          _this$props$highlight2 = _this$props.highlightedEndText,
          highlightedEndText = _this$props$highlight2 === void 0 ? '' : _this$props$highlight2;
      var highlightedLines = this.props.highlight.split(',').map(function (num) {
        if (num.indexOf('-') > 0) {
          // We found a line group, e.g. 1-3
          var _num$split$map$sort = num.split('-').map(Number) // Sort by lowest value first, highest value last.
          .sort(function (a, b) {
            return a - b;
          }),
              _num$split$map$sort2 = _slicedToArray(_num$split$map$sort, 2),
              from = _num$split$map$sort2[0],
              to = _num$split$map$sort2[1];

          return Array(to + 1).fill(undefined).map(function (_, index) {
            return index;
          }).slice(from, to + 1);
        }

        return Number(num);
      }).reduce(function (acc, val) {
        return acc.concat(val);
      }, []) || [];
      return jsx("div", {
        "data-testid": this.props.testId,
        "data-code-block": "",
        css: codeLayoutContainer(highlightedStartText, highlightedEndText, this.props.showLineNumbers)
      }, jsx(SyntaxHighlighter, _extends({
        "data-code-lang": this.props.language // Wrap lines is needed to set styles on the line.
        // We use this to set opacity if highlight specific lines.
        ,
        wrapLines: this.props.highlight.length > 0 || this.props.testId,
        lineProps: function lineProps(line) {
          return _this2.getHighlightStyles(line, highlightedLines);
        }
      }, props), this.props.text));
    }
  }]);

  return CodeBlock;
}(PureComponent);

_defineProperty(CodeBlock, "displayName", 'CodeBlock');

_defineProperty(CodeBlock, "defaultProps", {
  showLineNumbers: true,
  language: LANGUAGE_FALLBACK,
  theme: {},
  themeOverride: {},
  highlight: '',
  highlightedStartText: 'Highlight start',
  highlightedEndText: 'Highlight end'
});

export { CodeBlock as default };